/////////////////////////////////////////////////////////////////
//Copyright (C) 2005 NTT CORPORATION.
//
//	WBT個別ログ　進捗状況一覧(ユーザー単位)
//
//		変更履歴
//			2005.01.31  新規作成  OGA
//
//	機能
//
//	この画面は進捗状況一覧画面(ユーザー単位)を表示します
//
/////////////////////////////////////////////////////////////////

/*
 * 作成日: 2005/02/20
 *
 * TODO この生成されたファイルのテンプレートを変更するには次へジャンプ:
 * ウィンドウ - 設定 - Java - コード・スタイル - コード・テンプレート
 */
package jp.co.ntt.lms.xmf.actions.lo.wbt.IndividualLog;

import java.text.DecimalFormat;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.ntt.lms.xmf.actions.lo.wbt.IndividualLog.inc.*;
import jp.co.ntt.lms.lo.WBT.IndividualLog.*;
import jp.co.ntt.lms.Common.RDF.*;
import jp.co.ntt.lms.xmo.Assignments.AssignmentsClient;
import jp.co.ntt.lms.xmo.util.*;
import jp.co.ntt.lms.xmo.Lo.LoClient;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * @author Administrator
 *
 * TODO この生成された型コメントのテンプレートを変更するには次へジャンプ:
 * ウィンドウ - 設定 - Java - コード・スタイル - コード・テンプレート
 */
public class UserProgressStatusAction extends Action{
	private IndividualLogMessga_inc IndividualLogMessga_inc = new IndividualLogMessga_inc();
	private IndividualLogCommon_inc IndividualLogCommon_inc = new IndividualLogCommon_inc();
	private IndividualStub_inc IndividualStub_inc = new IndividualStub_inc();
	private IndividualLogComFunc_inc IndividualLogComFunc_inc = new IndividualLogComFunc_inc();

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		///////////////////////////////////////////
		// パラメータ取得
		// 	・LoID		LoID		// 必須
		// 	・userId	ユーザーID	// 必須
		// 	・LoType	Loタイプ	// 必須
		// 	・UID		UID			// 必須
		///////////////////////////////////////////
		///////////////////////////////////////////
		// パラメータ取得
		// 	・LoID		LoID		// 必須
		// 	・userId	ユーザーID	// 必須
		// 	・LoType	Loタイプ	// 必須
		// 	・UID		UID			// 必須
		///////////////////////////////////////////
		String strLoID_o         = request.getParameter( IndividualLogCommon_inc.STR_LOID_o );          // LoID
		String strUserID_o       = request.getParameter( IndividualLogCommon_inc.STR_USERID_o );        // ユーザーID
		String strLoType_o       = request.getParameter( IndividualLogCommon_inc.STR_LOTYPE_o );        // Loタイプ
		String strUID_o          = request.getParameter( IndividualLogCommon_inc.STR_UID_o );           // UID

		// RealLOID取得
		///////////////////////////////////////////

		///////////////////////////////////////////
		// パラメータチェック
		///////////////////////////////////////////
		
		// LoIDの入力チェック
		if( strLoID_o == null || strLoID_o.equals( "" ) ) {
			request.setAttribute("message", IndividualLogMessga_inc.M072001);
			request.setAttribute("detail", IndividualLogMessga_inc.D072001);
			request.setAttribute("close", "on");

			return mapping.findForward("error");
		}
		// ユーザーIDの入力チェック
		if( strUserID_o == null || strUserID_o.equals( "" ) ) {
			request.setAttribute("message", IndividualLogMessga_inc.M072002);
			request.setAttribute("detail", IndividualLogMessga_inc.D072002);
			request.setAttribute("close", "on");

			return mapping.findForward("error");
		}
		// Loタイプの入力チェック
		if( strLoType_o == null || strLoType_o.equals( "" ) ) {
			request.setAttribute("message", IndividualLogMessga_inc.M072003);
			request.setAttribute("detail", IndividualLogMessga_inc.D072003);
			request.setAttribute("close", "on");

			return mapping.findForward("error");
		}
		// UIDの入力チェック
		if( strUID_o == null || strUID_o.equals( "" ) ) {
			request.setAttribute("message", IndividualLogMessga_inc.M072004);
			request.setAttribute("detail", IndividualLogMessga_inc.D072004);
			request.setAttribute("close", "on");

			return mapping.findForward("error");
		}

		///////////////////////////////////////////
		// RDFNodeの取得
		// ・strUID_o	UID			必須
		///////////////////////////////////////////
		RDFNode objNode = (RDFNode)IndividualStub_inc.getTargetRDFNode( strUID_o , strLoID_o , request.getSession() );
		if( objNode == null ){
			request.setAttribute("message", IndividualLogCommon_inc.MSG_MAKE_STOREDATA_o);
			request.setAttribute("detail", "");
			request.setAttribute("close", "on");

			return mapping.findForward("error");
		}

		////////////////////////
		// データの取得
		////////////////////////
		IndividualLogUserProgressStatusStoreData objStoreData = new IndividualLogUserProgressStatusStoreData( strLoID_o, strUserID_o, strLoType_o , objNode);
		if( objStoreData.makeStoreData() != true ){
			request.setAttribute("message", IndividualLogCommon_inc.MSG_MAKE_STOREDATA_o);
			request.setAttribute("detail", "");
			request.setAttribute("close", "on");

			return mapping.findForward("error");
		}

		// データがない場合
		if( objStoreData.getMaxData() == 0 ){
			request.setAttribute("message", IndividualLogCommon_inc.MSG_DATA_ZERO_o);
			request.setAttribute("detail", "");
			request.setAttribute("close", "on");

			return mapping.findForward("error");
		}

		Vector vecStoreData = objStoreData.getStoreData(0);

		// アクセス回数・累積学習時間・得点（最新／最高）・完了AU数・合格AU数
		// 累積学習時間のみ、時間単位のために小数点以下がある。
		int intAccess = 0, intAccesscnt = 0;
		float fltStudyTime = 0, intStudyTimecnt = 0;
		float fltLastScore = 0;
		int intLastScorecnt = 0;
		float fltHighScore = 0;
		int intHighScorecnt = 0;
		int	intCompleteAU = 0, intCompleteAUcnt = 0;
		int	intPassAU = 0, intPassAUcnt = 0;

		// 受講中AU数
		int	intAttendAUcnt = 0;

		// 受講数（学習開始日のない、申し込みだけの受講も含む）
		int	intAttendcnt = 0;

		String strAU_ID = "   ";

		int intAU_ID;

		float fltAverage = 0;
		// 平均表示フォーマット
		DecimalFormat objAverageFormat = new DecimalFormat( IndividualLogCommon_inc.DEF_AVERAGE_FORMAT );
		// 得点表示フォーマット
		DecimalFormat objScoreFormat = new DecimalFormat( IndividualLogCommon_inc.DEF_SCORE_FORMAT );

		String	strScore;
		String	strAverage1, strSum1;
		String	strAverage2, strSum2;
		String	strAverage3, strSum3;
		String	strAverage4, strSum4;
		String	strAverage5, strSum5;
		String	strAverage6, strSum6;

		// 小数点以下第二位で四捨五入
		fltAverage = IndividualLogComFunc_inc.getMathRound( (float)intAccess, (float)intAccesscnt );

		// 表示用フォーマットに変換
		strSum1 = objScoreFormat.format(intAccess);
		strAverage1 = objAverageFormat.format(fltAverage);

		// 小数点以下第二位で四捨五入
		fltAverage = IndividualLogComFunc_inc.getMathRound( (float)fltStudyTime, (float)intStudyTimecnt );

		// 表示用フォーマットに変換
		strSum2 = objAverageFormat.format(fltStudyTime);
		strAverage2 = objAverageFormat.format(fltAverage);

		// 小数点以下第二位で四捨五入
		fltAverage = IndividualLogComFunc_inc.getMathRound( fltLastScore, (float)intLastScorecnt );

		// 表示用フォーマットに変換
		strSum3 = objScoreFormat.format(fltLastScore);
		strAverage3 = objAverageFormat.format(fltAverage);

		// 小数点以下第二位で四捨五入
		fltAverage = IndividualLogComFunc_inc.getMathRound( fltHighScore, (float)intHighScorecnt );

		// 表示用フォーマットに変換
		strSum4 = objScoreFormat.format(fltHighScore);
		strAverage4 = objAverageFormat.format(fltAverage);

		// パーセント表示　小数点以下第二位で四捨五入
		fltAverage = IndividualLogComFunc_inc.getMathRound2( (float)intCompleteAUcnt, (float)intAttendcnt );

		// 表示用フォーマットに変換
		strSum5 = objScoreFormat.format(intCompleteAUcnt);
		strAverage5 = objAverageFormat.format(fltAverage);

		// パーセント表示　小数点以下第二位で四捨五入
		fltAverage = IndividualLogComFunc_inc.getMathRound2( (float)intPassAUcnt, (float)intAttendcnt );

		// 表示用フォーマットに変換
		strSum6 = objScoreFormat.format(intPassAUcnt);
		strAverage6 = objAverageFormat.format(fltAverage);

		request.setAttribute("IndividualLogCommon_inc",IndividualLogCommon_inc);
		request.setAttribute("objStoreData",objStoreData);
		request.setAttribute("strLoID_o",strLoID_o);
		request.setAttribute("IndividualLogComFunc_inc",IndividualLogComFunc_inc);
		request.setAttribute("objAverageFormat",objAverageFormat);
		request.setAttribute("objScoreFormat",objScoreFormat);
		request.setAttribute("strAU_ID",strAU_ID);
						
		request.setAttribute("strSum1",strSum1);
		request.setAttribute("strSum2",strSum2);
		request.setAttribute("strSum3",strSum3);
		request.setAttribute("strSum4",strSum4);
		request.setAttribute("strSum5",strSum5);
		request.setAttribute("strSum6",strSum6);
				
		request.setAttribute("strAverage1",strAverage1);
		request.setAttribute("strAverage2",strAverage2);
		request.setAttribute("strAverage3",strAverage3);
		request.setAttribute("strAverage4",strAverage4);
		request.setAttribute("strAverage5",strAverage5);
		request.setAttribute("strAverage6",strAverage6);
		request.setAttribute("intLastScorecnt",new Integer(intLastScorecnt));
		request.setAttribute("intHighScorecnt",new Integer(intHighScorecnt));
		request.setAttribute("intAttendcnt",new Integer(intAttendcnt));
		
		
		return mapping.findForward("success");
	}
}
